﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Windows.Storage;
using System.IO;
using System.Threading.Tasks;

namespace GxGFanShared
{
    public class SettingManager
    {
        private static readonly string Filename = "Settings.txt";

        Windows.Storage.StorageFolder _localFolder = Windows.Storage.ApplicationData.Current.LocalFolder;

        public async Task<FacebookSettings> GetSettings()
        {
            FacebookSettings setting = null;
            try
            {
                var file = await _localFolder.CreateFileAsync(Filename, CreationCollisionOption.OpenIfExists);
#if WINDOWS_PHONE
                var stream = await file.OpenStreamForReadAsync();
                using (StreamReader streamReader = new StreamReader(stream))
                {
                    setting = FacebookSettings.GetSetting(streamReader.ReadToEnd());
                }
#endif
#if !WINDOWS_PHONE
                string jsonString = await FileIO.ReadTextAsync(file);
                setting = FacebookSettings.GetSetting(jsonString);
#endif
            }
            catch (Exception ex)
            {
                //logging errori
            }
            return setting;
        }

        public async Task<bool> SaveSetting(FacebookSettings setting)
        {
            try
            {
#if !WINDOWS_PHONE
            var file = await _localFolder.CreateFileAsync(Filename, CreationCollisionOption.ReplaceExisting);
            await FileIO.WriteTextAsync(file, setting.GetSerialized());
#endif
#if WINDOWS_PHONE
                var file = await _localFolder.CreateFileAsync(Filename, CreationCollisionOption.ReplaceExisting);
                byte[] fileBytes = System.Text.Encoding.UTF8.GetBytes(setting.GetSerialized());
                using (var s = await file.OpenStreamForWriteAsync())
                {
                    s.Write(fileBytes, 0, fileBytes.Length);
                }
#endif
                return true;
            }
            catch (Exception ex)
            {
                //logging errori
                return false;
            }
        }
    }
}
